From dd42c72287cc775673bfd7c1d35af8583b3d1569 Mon Sep 17 00:00:00 2001
From: David Tolnay <dtolnay@gmail.com>
Date: Dec 11 2020 22:05:26 +0000
Subject: [PATCH 1700/2232] Add Vec copy assignment operator


---

diff --git a/include/cxx.h b/include/cxx.h
index 22636fd..e3ef0be 100644
--- a/include/cxx.h
+++ b/include/cxx.h
@@ -246,6 +246,7 @@ public:
   ~Vec() noexcept;
 
   Vec &operator=(Vec &&) noexcept;
+  Vec &operator=(const Vec &);
 
   size_t size() const noexcept;
   bool empty() const noexcept;
@@ -676,6 +677,15 @@ Vec<T> &Vec<T>::operator=(Vec &&other) noexcept {
 }
 
 template <typename T>
+Vec<T> &Vec<T>::operator=(const Vec &other) {
+  if (this != &other) {
+    this->drop();
+    new (this) Vec(other);
+  }
+  return *this;
+}
+
+template <typename T>
 bool Vec<T>::empty() const noexcept {
   return size() == 0;
 }

